# author: Chantal Peeters
# date: 02.01.2013

ExaktGamma<- function(x,a,b,p,accuracy){  
  # Computes the sensitivity of P(C>x) with respect to the parameter of the 
  # geometric distribution (p) for C = "Compound Geometric Sum with 
  # Gamma distributed summands" with the law of total probability. 
  # Since infinite sums cannot be calculated with R, the first n summands are 
  # summed up, till the summand is bigger than the specified accuracy
  
  # input:
  #    - x
  #    - a, b: parameters of the gamma distribution
  #    - p: parameter of the geometric distribution
  #    - accuracy
  
	n=1;
	sensitivity = 0;
	summand = accuracy +1;
	while(summand > accuracy || s==0){
		s = 1/p - n/(1-p);
		p_C = 1-pgamma(x,shape=n*a,scale=(1/b));
		p_N = dgeom(n,p);
		sensitivity = s*p_C*p_N + sensitivity;
		summand = abs(s*p_C*p_N) 
		n= n+1;

	}
	return(sensitivity = sensitivity);
}
