# author: Chantal Peeters
# date: 02.01.2013

ExaktGammaZ<- function(x,a,b,p,accuracy){
  
  # Computes the probability P(C>x) for C = "Compound Geometric Sum with 
  # Gamma distributed summands" with the law of total probability. 
  # Since infinite sums cannot be calculated with R, the first n summands are summed up, 
  # till the summand is bigger than the specified accuracy
  
  # Args:
  #    - x
  #    - a, b: parameters of the gamma distribution
  #    - p: parameter of the geometric distribution
  #    - accuracy
  
	n=1;
	z = 0;
	summand = accuracy +1;
	while(summand > accuracy){
		p_C = 1-pgamma(x,shape=n*a,scale=(1/b));
		p_N = dgeom(n,p);
		z = p_C*p_N + z;
		summand = abs(p_C*p_N) 
		n= n+1;
	}
	return(z=z);
}
