# author: Chantal Peeters
# date: 02.01.2013

SimulationGamma<- function(x,a,b,p,n){ 
  # Computes the sensitivity of P(C>x) for C = "Compound Geometric Sum with Gamma 
  # distributed summands" with the Monte Carlo Method ISS.
  
  # Args:
  #    - x
  #    - a, b: parameters of the gamma distribution
  #    - p: parameter of the geometric distribution
  #    - n: simulation parameter
  
	s = matrix(0,nrow = n);
	Z = matrix(0,nrow = n);
	for (i in 1:n){
		N = rgeom(n=1,prob = p);
		if(N != 0){
			C = rgamma(n= 1,shape =N*a,scale=(1/b));
			if (C > x){ 
				Z[i]=1;
			}
			s[i] = 1/p-N/(1-p);
		}
	}
	sensitivity = mean(s*Z);
	return(sensitivity = sensitivity);
}
