# author: Chantal Peeters
# date: 02.01.2013

### C = Compound Poisson Sum with Gamma distributed summands
### Comparison B: lambda variable, x = 10.25

# Saddlepoints
x = 10.25;
alpha = 2;
beta = 1;

lambda = seq(0.08,14,by=0.08)
saddlepoints = rep(0,length(lambda))

for (i in 1:length(lambda)){
  saddlepoints[i] = beta - (lambda[i] * alpha * beta^alpha/x)^(1/(alpha+1));
}


## Graph
par(mfrow=c(1,1),mar=c(5.7,4.1,6.1,2.1));
plot(lambda,saddlepoints,type="l",lty=2,cex.axis=1.2,cex.lab=1.3,xlab=expression(lambda),
     ylab="Sattelpunkt",mgp=c(2.5,0.5,0),xlim=c(0,14),ylim=c(-0.4,0.5),col="blue",lwd=0.5);
abline(h=0,lwd=0.5);
dev.copy2pdf(file="B_Sattelpunkte.pdf",width=8,height=5.5)
dev.copy2eps(file="B_Sattelpunkte.eps",width=8,height=5.5)
dev.off()