# author: Chantal Peeters
# date: 02.01.2013

ExaktGamma<- function(x,a,b,lambda,accuracy){
# Computes the sensitivity of the probability P(C>x) for C = "Compound Poisson Sum 
# with Gamma distributed summands" with respect to the parameter of the Poisson
# distribution (lambda) with the law of total probability. 
# Since infinite sums cannot be calculated with R, the first n summands are summed up, till the 
# summand is bigger than the specified accuracy

# Args:
#    - x
#    - a, b: parameters of the gamma distribution
#    - lambda: parameter of the Poisson distribution
#    - accuracy

	n=1;
	sensitivity = 0;
	summand = accuracy +1;
	while(summand > accuracy || s==0){
		s = n/lambda - 1;
		p_C = 1-pgamma(x,shape=n*a,scale=1/b);
		p_N = dpois(n,lambda);
		sensitivity = s*p_C*p_N + sensitivity;
		summand = abs(s*p_C*p_N) 
		n= n+1;
	}
	return(sensitivity = sensitivity);
}

