# author: Chantal Peeters
# date: 02.01.2013

ExaktGammaZ<- function(x,a,b,lambda,accuracy){
  # Computes the sensitivity of P(C>x) for C = "Compound Poisson Sum with Gamma distributed 
  # summands" with the law of total probability. 
  # Since infinite sums cannot be calculated with R, the first n summands are summed up, till the 
  # summand is bigger than the specified accuracy
  
  # Args:
  #    - x
  #    - a, b: parameters of the gamma distribution
  #    - lambda: parameter of the Poisson distribution
  #    - accuracy

	n=1;
	z = 0;
	summand = accuracy +1;
	while(summand > accuracy){
		p_C = 1-pgamma(x,n*a,1/b);
		p_N = dpois(n,lambda);
		z = p_C*p_N +z;
		summand = abs(p_C*p_N) 
		n= n+1;
	}
	return(z=z);
}
