# author: Chantal Peeters
# date: 02.01.2013

M1_Y<- function(v,c,accuracy){  
  # Computes the first derivative of the moment generating function for the Weibull 
  # distribution.
  # Because this function is an infinte sum and since infinite sums cannot be 
  # calculated with R, the first n summands are summed up, till the summand is 
  # bigger than the specified accuracy.
  
  # Args:
  #    - v: point at which the function is evaluated
  #    - c: parameter of the Weibull distribution
  #    - accuracy
  
	M1 = 0;
	difference=1;
	n=0;

	while(difference > accuracy){
		M1_old = M1;
		M1 = gamma(1+(n+1)/c)*v^n/factorial(n)+ M1_old;
		difference = abs(M1-M1_old);
		n = n+1;		
	}
	return(M1_Y=M1);
}
