# author: Chantal Peeters
# date: 02.01.2013

M2_Y<- function(v,c,accuracy){
  # Computes the second derivative of the moment generating function for the Weibull 
  # distribution.
  # Because this function is an infinte sum and since infinite sums cannot be 
  # calculated with R, the first n summands are summed up, till the summand is 
  # bigger than the specified accuracy.
  
  # Args:
  #    - v: point at which the function is evaluated
  #    - c: parameter of the Weibull distribution
  #    - accuracy
  
	M2 = 0;
	difference=1;
	n=0;

	while(difference > accuracy){
		M2_old = M2;
		M2 = gamma(1+(n+2)/c)*v^n/factorial(n)+ M2_old;
		difference = abs(M2-M2_old);
		n = n+1;		
	}
	return(M2_Y=M2);
}
