# author: Chantal Peeters
# date: 02.01.2013

M3_Y<- function(v,c,accuracy){
  # Computes the third derivative of the moment generating function for the Weibull 
  # distribution.
  # Because this function is an infinte sum and since infinite sums cannot be 
  # calculated with R, the first n summands are summed up, till the summand is 
  # bigger than the specified accuracy.
  
  # Args:
  #    - v: point at which the function is evaluated
  #    - c: parameter of the Weibull distribution
  #    - accuracy
  
	M3 = 0;
	difference=1;
	n=0;

	while(difference > accuracy){
		M3_old = M3;
		M3 = gamma(1+(n+3)/c)*v^n/factorial(n)+ M3_old;
		difference = abs(M3-M3_old);
		n = n+1;		
	}
	return(M3_Y=M3);
}
