# author: Chantal Peeters
# date: 02.01.2013

M_Y<- function(v,c,accuracy){
  # Computes the moment generating function for the Weibull distribution.
  # Because this function is an infinte sum and since infinite sums cannot be 
  # calculated with R, the first n summands are summed up, till the summand is 
  # bigger than the specified accuracy.
  
  # Args:
  #    - v: point at which the moment generating function is evaluated
  #    - c: parameter of the Weibull distribution
  #    - accuracy
  
	M = 0;
	difference=1;
	n=0;

	while(difference > accuracy){
		M = gamma(1+n/c)*v^n/factorial(n)+ M;
		difference = abs(gamma(1+n/c)*v^n/factorial(n));
		n = n+1;		
	}
	return(M_Y=M);
}
