# author: Chantal Peeters
# date: 02.01.2013

SimulationWeibullZ<- function(x,c,lambda,n){
  # Computes the probability P(C>x) for C = "Compound Poisson Sum with Weibull
  # distributed summands" with the Monte Carlo Method.
  
  # Args:
  #    - x
  #    - c: parameter of the Weibull distribution
  #    - lambda: parameter of the Poisson distribution
  #    - n: simulation parameter
  
	s = matrix(0,nrow = n);
	Z = matrix(0,nrow = n);
	for (i in 1:n){
		N = rpois(n=1,lambda = lambda);
		if(N != 0){		
			Y = rweibull(n= N,shape =c);
			C = sum(Y);
			if (C > x){ 
				Z[i]=1;
			}
		}
	}
	probability = mean(Z);
	return(probability = probability);
}
